// ---------------------------------------------------------------------------
//       .
//
//   :
//  0 -  ()    .
//  1 -   .
//  2 -   .
//  3 -   .
//  4 -     ( ).
//
//   1.1:     -   
//                  .
// ---------------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DarkViolet
#property indicator_color2  LimeGreen
#property indicator_color3  Red
#property indicator_color4  Blue
#property indicator_width1  2
#property indicator_level1  0

//    .
#define ARROW_CHAR 0x6C

//  .
extern int  PERIOD_FROM = 5;
extern int  PERIOD_TO   = 15;
//   .
extern int  MULTIPLIER  = 100000;
//  .
extern int  SMOOTH      = 3;
//   .
extern int  DIGITS      = 2;
//    .
extern bool FAST_MARK   = true;

//  .
double buf_av[]; //  . 
double buf_d1[]; //  .
double buf_sm[]; //   .
double buf_mx[]; // .
double buf_mn[]; // .
//   .
int    sma_count;
//       .
int    work_period;

// .
int init() {
  if(PERIOD_FROM > PERIOD_TO) {
    int t = PERIOD_FROM;
    
    PERIOD_FROM = PERIOD_TO;
    PERIOD_TO   = t;
  }

  IndicatorShortName(StringConcatenate(
    "AZZX - D-DR1 v1.1 (", PERIOD_FROM, ", ", PERIOD_TO, ", ", 
    MULTIPLIER, ", ", SMOOTH, ", ", DIGITS, ", ", FAST_MARK, ")"));
  IndicatorDigits(DIGITS);
  IndicatorBuffers(5);

  SetIndexBuffer(0, buf_sm);
  SetIndexBuffer(1, buf_d1);
  SetIndexBuffer(2, buf_mx);
  SetIndexBuffer(3, buf_mn);
  SetIndexBuffer(4, buf_av);
  
  SetIndexLabel(0, "SMOOTHED");
  SetIndexLabel(1, "DERIVATIVE-1");
  SetIndexLabel(2, "MAXIMUM");
  SetIndexLabel(3, "MINIMUM");
  
  SetIndexStyle(2, DRAW_ARROW);
  SetIndexStyle(3, DRAW_ARROW);
  
  SetIndexArrow(2, ARROW_CHAR);
  SetIndexArrow(3, ARROW_CHAR);

  SetIndexEmptyValue(2, 0);
  SetIndexEmptyValue(3, 0);
  
  sma_count   = PERIOD_TO - PERIOD_FROM + 1;
  work_period = Bars - SMOOTH - 2;

  return(0);
}

//  .
int start() {
  int i, j;
  
  //  .
  for(i = Bars - IndicatorCounted() - 1; i >= 0; i--) {
    buf_av[i] = 0;
    buf_d1[i] = 0;
    buf_sm[i] = 0;

    //   .
    if(i < Bars - 1) {
      for(j = PERIOD_FROM; j <= PERIOD_TO; j++) {
        buf_av[i] += iMA(NULL, 0, j, 0, MODE_SMA, PRICE_CLOSE, i);
      }
      
      buf_av[i] /= sma_count;
    }

    //  .
    if(i < Bars - 2) {
      buf_d1[i] = (buf_av[i] - buf_av[i + 1]) * MULTIPLIER;
    }
    
    //  .
    if(i < work_period) {
      for(j = i + SMOOTH - 1; j >= i; j--) {
        buf_sm[i] += buf_d1[j];
      }
      
      buf_sm[i] /= SMOOTH;
    }
  }

  //  .
  if(FAST_MARK == true) {
    for(i = Bars - IndicatorCounted() - 1; i >= 0; i--) {
      buf_mx[i] = 0; 
      buf_mn[i] = 0;
    
      if(i < work_period - 1) {
        // .
        if((buf_d1[i + 1] >= buf_sm[i + 1]) && (buf_d1[i] < buf_sm[i])) {
          buf_mx[i] = buf_sm[i]; 
        }
      
        // .
        if((buf_d1[i + 1] <= buf_sm[i + 1]) && (buf_d1[i] > buf_sm[i])) {
          buf_mn[i] = buf_sm[i];
        }
      }    
    }
  } else {
    for(i = Bars - IndicatorCounted() - 1; i > 0; i--) {
      buf_mx[i] = 0; 
      buf_mn[i] = 0;
    
      if(i < work_period - 1) {
        // .
        if((buf_sm[i] > buf_sm[i + 1]) && (buf_sm[i] > buf_sm[i - 1])) {
          buf_mx[i] = buf_sm[i]; 
        }
      
        // .
        if((buf_sm[i] < buf_sm[i + 1]) && (buf_sm[i] < buf_sm[i - 1])) {
          buf_mn[i] = buf_sm[i];
        }
      }    
    }
  }

  //   ...
  buf_mx[0] = 0;
  buf_mn[0] = 0;

  return(0);
}

